您的位置:首页 > 其它

HDU - 1087 (最长上升子序列)

2017-08-14 15:14 375 查看


Super Jumping! Jumping! Jumping!

Problem Description

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In
the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping
can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his
jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.

Your task is to output the maximum value according to the given chessmen list.

 

Input

Input contains multiple test cases. Each test case is described in a line as follow:

N value_1 value_2 …value_N 

It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.

A test case starting with 0 terminates the input and this test case is not to be processed.

 

Output

For each case, print the maximum according to rules, and one line one case.

 

Sample Input

3 1 3 2
4 1 2 3 4
4 3 3 2 1
0

 

Sample Output

4
10
3

 

题意:最长上升子序列的和

解题思路:模板题。要理解状态转移方程的含义。dp[i]为前i个数中并且以a[i]结尾的最长上升子序列的和,那么dp[i]肯定是dp[0~(i-1)]中的最大值并且还要满足a[j]<a[i],0<j<i-1。假如 4 5 1 2 3这组数据,处理到第五个数的时候,3只比2大,但是3<5,所以不能dp[5]=dp[2]+a[5],而应该是dp[5]=dp[4]+a[5],因为a[4]<a[5],但a[5]<a[2]

用代码写就是

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <string.h>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#define ll long long
using namespace std;

int N;
int a[1005];
int dp[1005];

int main(){

while(~scanf("%d",&N)){

if(N==0)
break;

for(int i=0;i<N;i++)
scanf("%d",&a[i]);

for(int i=0;i<N;i++)
dp[i]=a[i];

for(int i=1;i<N;i++)
for(int j=0;j<i;j++){
if(a[j]<a[i])
dp[i]=max(dp[i],dp[j]+a[i]);
}

int maxnum=dp[0];
for(int i=1;i<N;i++)
maxnum=max(maxnum,dp[i]);

cout<<maxnum<<endl;

}

return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: